#include <QtCore>
#include <QtNetwork>

int main(int argc, char **argv) {
    QCoreApplication app(argc, argv);
    QFile file(QStringLiteral("server-data"));
    file.open(QIODevice::ReadOnly);
    QByteArray data = file.readAll();
    QTcpServer server;
    QHostAddress address(QHostAddress::LocalHost);
    server.listen(address);
    QUrl serverUrl(QStringLiteral("http://") + server.serverAddress().toString() + QStringLiteral(":") + QString::number(server.serverPort()) + QStringLiteral("/"));
    QObject::connect(&server, &QTcpServer::newConnection, [&server, data]() {
        while (server.hasPendingConnections()) {
            QTcpSocket *socket = server.nextPendingConnection();
            socket->waitForReadyRead();
            socket->write(data);
            socket->waitForBytesWritten();
            socket->disconnectFromHost();
            QObject::connect(socket, &QTcpSocket::disconnected, &QTcpSocket::deleteLater);
        }
    });
    QNetworkRequest request(serverUrl);
    QNetworkAccessManager manager;
    QNetworkReply *reply = manager.get(request);
    QObject::connect(reply, &QNetworkReply::finished, &app, &QCoreApplication::quit);
    app.exec();
    qDebug() << "reply error:" << reply->errorString();
    delete reply;
    return 0;
}
